
-- =============================================
-- Author		:	FID.Ridwan
-- Create date	:	05-Oct-2020
-- Description	:	Preparation Goods Receipt to ICS
-- Update		: 
-- =============================================
CREATE PROCEDURE [dbo].[SP_COMMON_GR_CREATE_NEW_PO_ITEM_DETAIL] @tb_s_po_h dbo.[tb_s_po_h] READONLY
	,@tb_s_comp_price dbo.[tb_s_comp_price] READONLY
	,@USER_ID VARCHAR(20) = 'AGAN'
	,@PROCESS_ID BIGINT = '202009230021'
	,@a_po_no VARCHAR(100)
	,@a_po_item_no VARCHAR(100)
	,@ri_d_delivery_dt DATE
	,@ri_v_flagsts VARCHAR(10)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	DECLARE @MODULE_ID VARCHAR(50) = '4'
		,@FUNCTION_ID VARCHAR(100) = '42005'
		,@IsError CHAR(1) = 'N'
		,@CURRDT DATE = CAST(GETDATE() AS DATE)
		,@MSG_TXT AS VARCHAR(MAX)
		,@MSG_TYPE AS VARCHAR(MAX)
		,@LOG_LOCATION AS VARCHAR(MAX) = 'SP_COMMON_GR_CREATE_NEW_PO_ITEM_DETAIL'
		,@L_ERR AS INT = 0
		,@N_ERR AS INT = 0
		,@PARAM1 AS VARCHAR(MAX)
		,@PARAM2 AS VARCHAR(MAX)
		,@PARAM3 AS VARCHAR(MAX)
		,@RES INT = 1;

	BEGIN TRY
		EXEC dbo.CommonGetMessage 'MPCS00002INF'
			,@MSG_TXT OUTPUT
			,@N_ERR OUTPUT
			,'Create PO Item Detail'

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @PROCESS_ID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D
				WHERE PROCESS_ID = @PROCESS_ID
				)
			,'MPCS00002INF'
			,'INF'
			,'MPCS00002INF : ' + @MSG_TXT
			,@LOG_LOCATION
			,@USER_ID
			,GETDATE()

		DECLARE @l_n_sum_mat_price INT = 0
			,@l_n_idx_rec INT = 0
			,@l_n_rec INT = 1
			,@l_n_sum_base INT = 0
			,@l_v_tax_cd VARCHAR(2)
			,@l_n_exchange_rate NUMERIC(13, 3)
			,@l_v_supp_cd VARCHAR(100)
			,@l_v_curr_cd VARCHAR(100)
			,@l_n_count INT = 0
			,@r_v_msg_id VARCHAR(100)
			,@l_n_qty_gr NUMERIC(13, 3)
			,@l_n_qty_ori NUMERIC(13, 3)
			,@l_n_stat_lock INT = 0
			,@r_v_msg VARCHAR(100)
			,@l_n_qty_new INT = 0
			,@l_n_qty_open INT = 0
			,@l_v_unlimited_flag VARCHAR(1)
			,@l_v_err_msg VARCHAR(1000) = ''
			,@l_v_po_item_no VARCHAR(10);
		-- PO ITEM
		DECLARE @PO_NO_ITM VARCHAR(100)
			,@PO_ITEM_NO_ITM VARCHAR(100)
			,@PR_NO_ITM VARCHAR(100)
			,@PR_ITEM_ITM VARCHAR(100)
			,@MAT_NO_ITM VARCHAR(100)
			,@SOURCE_TYPE_ITM VARCHAR(100)
			,@PLANT_CD_ITM VARCHAR(100)
			,@PROD_PURPOSE_CD_ITM VARCHAR(100)
			,@SLOC_CD_ITM VARCHAR(100)
			,@PART_COLOR_SFX_ITM VARCHAR(100)
			,@UNLIMITED_FLAG_ITM VARCHAR(100)
			,@TOLERANCE_PERCENTAGE_ITM NUMERIC(13, 3)
			,@PO_GR_QUANTITY_ITM NUMERIC(13, 3) = 0
			,@CONTAINER_NO_ITM VARCHAR(100)
			,@NOTE_ITM VARCHAR(100)
			,@SPECIAL_PROCUREMENT_TYPE_CD_ITM VARCHAR(100)
			,@MAT_DESC_ITM VARCHAR(100)
			,@PO_QUANTITY_ORIGINAL_ITM NUMERIC(13, 3)
			,@PO_QUANTITY_NEW_ITM NUMERIC(13, 3)
			,@PO_QUANTITY_OPEN_ITM NUMERIC(13, 3)
			,@UNIT_OF_MEASURE_CD_ITM VARCHAR(100)
			,@PO_MAT_PRICE_ITM NUMERIC(16, 5)
			,@DELIVERY_DT_ITM DATE
			,@DELETION_FLAG_ITM VARCHAR(100)
			,@TAX_CD_ITM VARCHAR(100)
			,@PACKING_TYPE_ITM VARCHAR(100);
		DECLARE @PO_NO_PAR VARCHAR(100)
			,@MAT_NO_PAR VARCHAR(100)
			,@SOURCE_TYPE_PAR VARCHAR(100)
			,@PROD_PURPOSE_CD_PAR VARCHAR(100)
			,@PACKING_TYPE_PAR VARCHAR(100)
			,@PLANT_CD_PAR VARCHAR(100)
			,@SLOC_CD_PAR VARCHAR(100)
			,@PROD_MONTH_PAR VARCHAR(100)
			,@QUANTITY_PAR INT
			,@PART_COLOR_SUFFIX_PAR VARCHAR(100)
			,@MAT_DESC_PAR VARCHAR(100)
			,@UOM_PAR VARCHAR(100)
			,@SPECIAL_PROC_TYPE_PAR VARCHAR(100)
			,@SUPP_CD_PAR VARCHAR(100)
			,@MAT_PRICE_PAR NUMERIC(16, 5)
			,@CALC_SCHEMA_CD_PAR VARCHAR(100)
			,@PAYMENT_METHOD_CD_PAR VARCHAR(100)
			,@PAYMENT_TERM_CD_PAR VARCHAR(100)
			,@CURR_CD_PAR VARCHAR(100)

		SELECT @PO_NO_PAR = PO_NO
			,@MAT_NO_PAR = MAT_NO
			,@SOURCE_TYPE_PAR = SOURCE_TYPE
			,@PROD_PURPOSE_CD_PAR = PROD_PURPOSE_CD
			,@PACKING_TYPE_PAR = PACKING_TYPE
			,@PLANT_CD_PAR = PLANT_CD
			,@SLOC_CD_PAR = SLOC_CD
			,@PROD_MONTH_PAR = PROD_MONTH
			,@QUANTITY_PAR = QUANTITY
			,@PART_COLOR_SUFFIX_PAR = PART_COLOR_SUFFIX
			,@MAT_DESC_PAR = MAT_DESC
			,@UOM_PAR = UOM
			,@SPECIAL_PROC_TYPE_PAR = SPECIAL_PROC_TYPE
			,@SUPP_CD_PAR = SUPP_CD
			,@MAT_PRICE_PAR = MAT_PRICE
			,@CALC_SCHEMA_CD_PAR = CALC_SCHEMA_CD
			,@PAYMENT_METHOD_CD_PAR = PAYMENT_METHOD_CD
			,@PAYMENT_TERM_CD_PAR = PAYMENT_TERM_CD
			,@CURR_CD_PAR = CURR_CD
		FROM @tb_s_po_h

		--- Get Latest PO Item Number on PO Item Table
		--- Increment PO item Number
		SELECT @l_v_po_item_no = RIGHT('00000' + CAST(isnull(CAST(MAX(PO_ITEM_NO) AS INT), 0) + 1 AS VARCHAR), 5)
		FROM TB_R_PO_ITEM
		WHERE PO_NO = @a_po_no;

		-- 3. Set Po Data on Array Variable
		SET @PR_NO_ITM = NULL;
		SET @PR_ITEM_ITM = NULL;
		SET @PROD_PURPOSE_CD_ITM = @PROD_PURPOSE_CD_PAR;
		SET @MAT_NO_ITM = @MAT_NO_PAR;
		SET @SOURCE_TYPE_ITM = @SOURCE_TYPE_PAR;
		SET @PART_COLOR_SFX_ITM = @PART_COLOR_SUFFIX_PAR;
		SET @PLANT_CD_ITM = @PLANT_CD_PAR;
		SET @SLOC_CD_ITM = @SLOC_CD_PAR;
		SET @SPECIAL_PROCUREMENT_TYPE_CD_ITM = @SPECIAL_PROC_TYPE_PAR;
		SET @MAT_DESC_ITM = @MAT_DESC_PAR;
		SET @UNIT_OF_MEASURE_CD_ITM = @UOM_PAR;
		SET @UNLIMITED_FLAG_ITM = 'Y';
		SET @TOLERANCE_PERCENTAGE_ITM = 0;
		SET @PACKING_TYPE_ITM = @PACKING_TYPE_PAR;
		SET @PO_MAT_PRICE_ITM = @MAT_PRICE_PAR;
		SET @TAX_CD_ITM = NULL;
		SET @DELIVERY_DT_ITM = @ri_d_delivery_dt;
		SET @DELETION_FLAG_ITM = 'N';
		SET @CONTAINER_NO_ITM = NULL;
		SET @NOTE_ITM = NULL;
		SET @PO_QUANTITY_ORIGINAL_ITM = @QUANTITY_PAR
		SET @PO_QUANTITY_NEW_ITM = @QUANTITY_PAR
		SET @PO_QUANTITY_OPEN_ITM = @QUANTITY_PAR

		---- PO DETAIL (Create PO Detail Data)
		---  Set Component Price Rate)
		-- PO DETAIL
		DECLARE @CALCULATION_SCHEMA_CD_DET VARCHAR(4)
			,@SEQ_NO_DET NUMERIC(3, 0)
			,@COMP_PRICE_CD_DET VARCHAR(4)
			,@COMP_PRICE_TEXT_DET VARCHAR(40)
			,@CALCULATION_TYPE_DET VARCHAR(1)
			,@PLUS_MINUS_FLAG_DET VARCHAR(1)
			,@INVENTORY_FLAG_DET VARCHAR(1)
			,@CONDITION_CATEGORY_DET VARCHAR(1)
			,@BASE_VALUE_F_DET NUMERIC(3, 0)
			,@BASE_VALUE_T_DET NUMERIC(3, 0)
			,@CONDITION_RULE_DET VARCHAR(1)
			,@ACCRUAL_FLAG_TYPE_DET VARCHAR(1)
			,@COMP_PRICE_RATE_DET NUMERIC(16, 0)
			,@TAX_CD_DET VARCHAR(20)
			,@SUPP_CD_DELIVERY_DET VARCHAR(20)
			,@PRICE_DET NUMERIC(16, 0)
			--2
			,@PO_NO VARCHAR(100)
			,@PO_ITEM_NO VARCHAR(100)
			,@COMP_PRICE_CD VARCHAR(100)
			,@COMP_PRICE_RATE NUMERIC(16, 2)
			,@INVOICE_FLAG VARCHAR(100)
			,@PO_EXCHANGE_RATE NUMERIC(16, 2)
			,@SUPP_CD VARCHAR(100)
			,@PO_CURR VARCHAR(100)
			,@PO_DETAIL_PRICE NUMERIC(16, 2)
			,@PO_DETAIL_AMT NUMERIC(16, 2)
			,@INVENTORY_FLAG VARCHAR(100)
			,@ACCRUAL_POSTING_FLAG VARCHAR(100)
			,@CONDITION_CATEGORY VARCHAR(100)
			,@SEQ_NO NUMERIC(3)
			,@BASE_VALUE_F NUMERIC(3)
			,@BASE_VALUE_T NUMERIC(3)
			,@CALCULATION_TYPE VARCHAR(100)
			,@PLUS_MINUS_FLAG VARCHAR(100);

		IF OBJECT_ID('tempdb..#c_get_comp_price') IS NOT NULL
		BEGIN
			DROP TABLE #c_get_comp_price
		END;

		CREATE TABLE #c_get_comp_price (
			[ROWNO] INT
			,[CALCULATION_SCHEMA_CD] [varchar](4) NOT NULL
			,[SEQ_NO] [numeric](3, 0) NULL
			,[COMP_PRICE_CD] [varchar](4) NOT NULL
			,[COMP_PRICE_TEXT] [varchar](40) NOT NULL
			,[CALCULATION_TYPE] [varchar](1) NOT NULL
			,[PLUS_MINUS_FLAG] [varchar](1) NOT NULL
			,[INVENTORY_FLAG] [varchar](1) NULL
			,[CONDITION_CATEGORY] [varchar](1) NOT NULL
			,[BASE_VALUE_F] [numeric](3, 0) NULL
			,[BASE_VALUE_T] [numeric](3, 0) NULL
			,[CONDITION_RULE] [varchar](1) NOT NULL
			,[ACCRUAL_FLAG_TYPE] [varchar](1) NOT NULL
			,[COMP_PRICE_RATE] [numeric](16, 0) NULL
			,[TAX_CD] [varchar](20) NULL
			,[SUPP_CD_DELIVERY] [varchar](20) NULL
			,[PRICE] [numeric](16, 0) NULL
			)

		IF OBJECT_ID('tempdb..#c_result_comp_price') IS NOT NULL
		BEGIN
			DROP TABLE #c_result_comp_price
		END;

		CREATE TABLE #c_result_comp_price (
			[ROWNO] INT
			,[CALCULATION_SCHEMA_CD] [varchar](4) NOT NULL
			,[SEQ_NO] [numeric](3, 0) NULL
			,[COMP_PRICE_CD] [varchar](4) NOT NULL
			,[COMP_PRICE_TEXT] [varchar](40) NOT NULL
			,[CALCULATION_TYPE] [varchar](1) NOT NULL
			,[PLUS_MINUS_FLAG] [varchar](1) NOT NULL
			,[INVENTORY_FLAG] [varchar](1) NULL
			,[CONDITION_CATEGORY] [varchar](1) NOT NULL
			,[BASE_VALUE_F] [numeric](3, 0) NULL
			,[BASE_VALUE_T] [numeric](3, 0) NULL
			,[CONDITION_RULE] [varchar](1) NOT NULL
			,[ACCRUAL_FLAG_TYPE] [varchar](1) NOT NULL
			,[COMP_PRICE_RATE] [numeric](16, 0) NULL
			,[TAX_CD] [varchar](20) NULL
			,[SUPP_CD_DELIVERY] [varchar](20) NULL
			,[PRICE] [numeric](16, 0) NULL
			)

		INSERT INTO #c_get_comp_price
		SELECT ROW_NUMBER() OVER (
				ORDER BY (
						SELECT 1
						)
				) ROWNO
			,CALCULATION_SCHEMA_CD
			,SEQ_NO
			,COMP_PRICE_CD
			,COMP_PRICE_TEXT
			,CALCULATION_TYPE
			,PLUS_MINUS_FLAG
			,INVENTORY_FLAG
			,CONDITION_CATEGORY
			,BASE_VALUE_F
			,BASE_VALUE_T
			,CONDITION_RULE
			,ACCRUAL_FLAG_TYPE
			,COMP_PRICE_RATE
			,TAX_CD
			,SUPP_CD_DELIVERY
			,PRICE
		FROM @tb_s_comp_price

		DECLARE @CN INT = 1
			,@CN_ALL INT = 0;

		SELECT @CN_ALL = COUNT(1)
		FROM #c_get_comp_price

		WHILE @CN <= @CN_ALL
		BEGIN
			SELECT @CALCULATION_SCHEMA_CD_DET = CALCULATION_SCHEMA_CD
				,@SEQ_NO_DET = SEQ_NO
				,@COMP_PRICE_CD_DET = COMP_PRICE_CD
				,@COMP_PRICE_TEXT_DET = COMP_PRICE_TEXT
				,@CALCULATION_TYPE_DET = CALCULATION_TYPE
				,@PLUS_MINUS_FLAG_DET = PLUS_MINUS_FLAG
				,@INVENTORY_FLAG_DET = INVENTORY_FLAG
				,@CONDITION_CATEGORY_DET = CONDITION_CATEGORY
				,@BASE_VALUE_F_DET = BASE_VALUE_F
				,@BASE_VALUE_T_DET = BASE_VALUE_T
				,@CONDITION_RULE_DET = CONDITION_RULE
				,@ACCRUAL_FLAG_TYPE_DET = ACCRUAL_FLAG_TYPE
				,@COMP_PRICE_RATE_DET = COMP_PRICE_RATE
				,@TAX_CD_DET = TAX_CD
				,@SUPP_CD_DELIVERY_DET = SUPP_CD_DELIVERY
				,@PRICE_DET = PRICE
			FROM #c_get_comp_price
			WHERE ROWNO = @CN

			IF @CONDITION_CATEGORY_DET = 'H'
			BEGIN
				SET @COMP_PRICE_RATE_DET = @MAT_PRICE_PAR;
				SET @SUPP_CD_DELIVERY_DET = @SUPP_CD_PAR;
			END --@CONDITION_CATEGORY_DET = 'H'
			ELSE
			BEGIN
				IF @CONDITION_RULE_DET = 'P'
				BEGIN
					SELECT @COMP_PRICE_RATE_DET = COMP_PRICE_RATE
						,@TAX_CD_DET = TAX_CD
						,@SUPP_CD_DELIVERY_DET = SUPP_CD_DELIVERY
					FROM TB_M_RATE_PRICE_COMP
					WHERE CONDITION_RULE = @CONDITION_RULE_DET
						AND COMP_PRICE_CD = @COMP_PRICE_CD_DET
						AND MAT_NO = @MAT_NO_PAR
						AND SOURCE_TYPE = @SOURCE_TYPE_PAR
						AND PROD_PURPOSE_CD = @PROD_PURPOSE_CD_PAR
						AND CONVERT(VARCHAR, VALID_FR, 112) <= CONVERT(VARCHAR, @ri_d_delivery_dt, 112)
						AND ISNULL(CONVERT(VARCHAR, VALID_TO, 112), '99991231') >= CONVERT(VARCHAR, @ri_d_delivery_dt, 112);
				END -- @CONDITION_RULE_DET = 'P'
				ELSE
					IF @CONDITION_RULE_DET = 'V'
					BEGIN
						SELECT @COMP_PRICE_RATE_DET = COMP_PRICE_RATE
							,@TAX_CD_DET = TAX_CD
							,@SUPP_CD_DELIVERY_DET = SUPP_CD_DELIVERY
						FROM TB_M_RATE_PRICE_COMP
						WHERE CONDITION_RULE = @CONDITION_RULE_DET
							AND COMP_PRICE_CD = @COMP_PRICE_CD_DET
							AND SUPP_CD = @SUPP_CD_PAR
							AND CONVERT(VARCHAR, VALID_FR, 112) <= CONVERT(VARCHAR, @ri_d_delivery_dt, 112)
							AND ISNULL(CONVERT(VARCHAR, VALID_TO, 112), '99991231') >= CONVERT(VARCHAR, @ri_d_delivery_dt, 112);
					END --@CONDITION_RULE_DET = 'V'
			END --@CONDITION_CATEGORY_DET <> 'H'

			INSERT INTO #c_result_comp_price
			SELECT @CN
				,@CALCULATION_SCHEMA_CD_DET
				,@SEQ_NO_DET
				,@COMP_PRICE_CD_DET
				,@COMP_PRICE_TEXT_DET
				,@CALCULATION_TYPE_DET
				,@PLUS_MINUS_FLAG_DET
				,@INVENTORY_FLAG_DET
				,@CONDITION_CATEGORY_DET
				,@BASE_VALUE_F_DET
				,@BASE_VALUE_T_DET
				,@CONDITION_RULE_DET
				,@ACCRUAL_FLAG_TYPE_DET
				,@COMP_PRICE_RATE_DET
				,@TAX_CD_DET
				,@SUPP_CD_DELIVERY_DET
				,@PRICE_DET

			SET @CN = @CN + 1;
		END -- END LOOP

		----- PO DETAIL (Calculation Component Price)
		SET @CN = 1;
		SET @CN_ALL = 0;

		DECLARE @CN_DET1 INT = 1
			,@SEQ_NO_PRICE_DET NUMERIC(3, 0)
			,@PRICE_PRICE_DET NUMERIC(16, 0);

		SELECT @CN_ALL = COUNT(1)
		FROM #c_get_comp_price

		WHILE @CN <= @CN_ALL
		BEGIN
			SELECT @CALCULATION_SCHEMA_CD_DET = CALCULATION_SCHEMA_CD
				,@SEQ_NO_DET = SEQ_NO
				,@COMP_PRICE_CD_DET = COMP_PRICE_CD
				,@COMP_PRICE_TEXT_DET = COMP_PRICE_TEXT
				,@CALCULATION_TYPE_DET = CALCULATION_TYPE
				,@PLUS_MINUS_FLAG_DET = PLUS_MINUS_FLAG
				,@INVENTORY_FLAG_DET = INVENTORY_FLAG
				,@CONDITION_CATEGORY_DET = CONDITION_CATEGORY
				,@BASE_VALUE_F_DET = BASE_VALUE_F
				,@BASE_VALUE_T_DET = BASE_VALUE_T
				,@CONDITION_RULE_DET = CONDITION_RULE
				,@ACCRUAL_FLAG_TYPE_DET = ACCRUAL_FLAG_TYPE
				,@COMP_PRICE_RATE_DET = COMP_PRICE_RATE
				,@TAX_CD_DET = TAX_CD
				,@SUPP_CD_DELIVERY_DET = SUPP_CD_DELIVERY
				,@PRICE_DET = PRICE
			FROM #c_result_comp_price
			WHERE ROWNO = @CN

			IF @CONDITION_CATEGORY_DET = 'H'
			BEGIN
				IF @PLUS_MINUS_FLAG_DET = '2'
				BEGIN
					SET @PRICE_DET = @COMP_PRICE_RATE_DET * (- 1);
				END -- @PLUS_MINUS_FLAG_DET = '2'
				ELSE
				BEGIN
					SET @PRICE_DET = @COMP_PRICE_RATE_DET;
				END --@PLUS_MINUS_FLAG_DET <> '2'
			END --@CONDITION_CATEGORY_DET = 'H'
			ELSE
			BEGIN
				IF @CALCULATION_TYPE_DET = '1'
				BEGIN
					SET @PRICE_DET = @COMP_PRICE_RATE_DET;
				END --@CALCULATION_TYPE_DET = '1'
				ELSE
					IF @CALCULATION_TYPE_DET = '2'
					BEGIN
						SET @PRICE_DET = @COMP_PRICE_RATE_DET / @PO_QUANTITY_NEW_ITM;
					END -- @CALCULATION_TYPE_DET = '2'
					ELSE
						IF @CALCULATION_TYPE_DET = '3'
						BEGIN
							IF ISNULL(@BASE_VALUE_T_DET, '') <> ''
							BEGIN
								SET @CN_DET1 = 1;
								SET @l_n_sum_base = 0;

								WHILE @CN_DET1 <= @CN_ALL
								BEGIN
									SELECT @SEQ_NO_PRICE_DET = SEQ_NO
										,@PRICE_PRICE_DET = PRICE
									FROM #c_get_comp_price
									WHERE ROWNO = @CN_DET1

									IF @SEQ_NO_PRICE_DET BETWEEN @BASE_VALUE_F_DET
											AND @BASE_VALUE_T_DET
									BEGIN
										-- summary value price from base_FR and base_TO
										SET @l_n_sum_base = @l_n_sum_base + @PRICE_PRICE_DET;
									END;

									SET @CN_DET1 = @CN_DET1 + 1;
								END -- END LOOP DETAIL

								--SET PRICE = RATE/100 * SUMMARY PRICES FROM BASE_VALUE_F AND BASE_VALUE_T
								SET @PRICE_DET = (@COMP_PRICE_RATE_DET / 100) * @l_n_sum_base;
							END --ISNULL(@BASE_VALUE_T_DET, '') <> ''
							ELSE
								IF ISNULL(@BASE_VALUE_T_DET, '') = ''
								BEGIN
									-- reset variable sum before looping
									SET @CN_DET1 = 1;
									SET @l_n_sum_base = 0;

									WHILE @CN_DET1 <= @CN_ALL
									BEGIN
										SELECT @SEQ_NO_PRICE_DET = SEQ_NO
											,@PRICE_PRICE_DET = PRICE
										FROM #c_get_comp_price
										WHERE ROWNO = @CN_DET1

										IF @SEQ_NO_PRICE_DET = @BASE_VALUE_F_DET
										BEGIN
											-- get the value price from base_FR
											SET @l_n_sum_base = @PRICE_PRICE_DET;
										END;

										SET @CN_DET1 = @CN_DET1 + 1;
									END -- END LOOP DETAIL

									--SET PRICE = RATE/100 * PRICE ON BASE_FR INDEX
									SET @PRICE_DET = (@COMP_PRICE_RATE_DET / 100) * @l_n_sum_base;
								END -- ISNULL(@BASE_VALUE_T_DET, '') = ''
						END -- @CALCULATION_TYPE_DET = '3'
						ELSE
							IF @CALCULATION_TYPE_DET = '4'
							BEGIN
								IF ISNULL(@BASE_VALUE_T_DET, '') <> ''
								BEGIN
									-- reset variable sum before looping
									SET @CN_DET1 = 1;
									SET @l_n_sum_base = 0;

									WHILE @CN_DET1 <= @CN_ALL
									BEGIN
										SELECT @SEQ_NO_PRICE_DET = SEQ_NO
											,@PRICE_PRICE_DET = PRICE
										FROM #c_get_comp_price
										WHERE ROWNO = @CN_DET1

										IF @SEQ_NO_PRICE_DET BETWEEN @BASE_VALUE_F_DET
												AND @BASE_VALUE_T_DET
										BEGIN
											-- summary value price from base_FR and base_TO
											SET @l_n_sum_base = @l_n_sum_base + @PRICE_DET;
										END;

										SET @CN_DET1 = @CN_DET1 + 1;
									END -- END LOOP DETAIL

									--SET PRICE = SUMMARY PRICES FROM BASE_FR AND BASE_To
									SET @PRICE_DET = @l_n_sum_base;
								END -- ISNULL(@BASE_VALUE_T_DET,'') <> ''
								ELSE
									IF ISNULL(@BASE_VALUE_T_DET, '') = ''
									BEGIN
										-- reset variable sum before looping
										SET @CN_DET1 = 1;
										SET @l_n_sum_base = 0;

										WHILE @CN_DET1 <= @CN_ALL
										BEGIN
											SELECT @SEQ_NO_PRICE_DET = SEQ_NO
												,@PRICE_PRICE_DET = PRICE
											FROM #c_get_comp_price
											WHERE ROWNO = @CN_DET1

											IF @SEQ_NO_PRICE_DET = @BASE_VALUE_F_DET
											BEGIN
												-- get the price From base_FR
												SET @l_n_sum_base = @PRICE_PRICE_DET;
											END;

											SET @CN_DET1 = @CN_DET1 + 1;
										END -- END LOOP DETAIL

										--SET PRICE = RATE/100 * PRICE ON BASE_F INDEX
										SET @PRICE_DET = @l_n_sum_base;
									END -- ISNULL(@BASE_VALUE_T_DET, '') = ''
							END -- @CALCULATION_TYPE_DET = '4'

				IF @PLUS_MINUS_FLAG_DET = 2
				BEGIN
					SET @PRICE_DET = @PRICE_DET * (- 1);
				END
				ELSE
				BEGIN
					SET @PRICE_DET = @PRICE_DET;
				END;
			END --@CONDITION_CATEGORY_DET <> 'H'

			UPDATE A
			SET A.CALCULATION_SCHEMA_CD = @CALCULATION_SCHEMA_CD_DET
				,A.SEQ_NO = @SEQ_NO_DET
				,A.COMP_PRICE_CD = @COMP_PRICE_CD_DET
				,A.COMP_PRICE_TEXT = @COMP_PRICE_TEXT_DET
				,A.CALCULATION_TYPE = @CALCULATION_TYPE_DET
				,A.PLUS_MINUS_FLAG = @PLUS_MINUS_FLAG_DET
				,A.INVENTORY_FLAG = @INVENTORY_FLAG_DET
				,A.CONDITION_CATEGORY = @CONDITION_CATEGORY_DET
				,A.BASE_VALUE_F = @BASE_VALUE_F_DET
				,A.BASE_VALUE_T = @BASE_VALUE_T_DET
				,A.CONDITION_RULE = @CONDITION_RULE_DET
				,A.ACCRUAL_FLAG_TYPE = @ACCRUAL_FLAG_TYPE_DET
				,A.COMP_PRICE_RATE = @COMP_PRICE_RATE_DET
				,A.TAX_CD = @TAX_CD_DET
				,A.SUPP_CD_DELIVERY = @SUPP_CD_DELIVERY_DET
				,A.PRICE = @PRICE_DET
			FROM #c_result_comp_price A
			WHERE A.ROWNO = @CN

			SET @CN = @CN + 1;
		END -- END LOOP MAIN

		---- PO DETAIL (Create PO Detail Data)
		--- Get Exchange Rate to PO Header
		--- lRec_PoDataSourceVar to @tb_s_po_h
		--- lRec_Get_Comp_Price to @tb_s_comp_price 
		SELECT @l_n_exchange_rate = a.EXCHANGE_RATE
			,@l_v_supp_cd = a.SUPPLIER_CD
			,@l_v_curr_cd = a.po_curr
		FROM TB_R_PO_H a
		WHERE a.PO_NO = @a_po_no;

		SET @CN = 1;
		SET @CN_ALL = 0;

		SELECT @CN_ALL = COUNT(1)
		FROM #c_get_comp_price

		SET @l_n_sum_mat_price = 0;

		WHILE @CN <= @CN_ALL
		BEGIN
			SELECT @CALCULATION_SCHEMA_CD_DET = CALCULATION_SCHEMA_CD
				,@SEQ_NO_DET = SEQ_NO
				,@COMP_PRICE_CD_DET = COMP_PRICE_CD
				,@COMP_PRICE_TEXT_DET = COMP_PRICE_TEXT
				,@CALCULATION_TYPE_DET = CALCULATION_TYPE
				,@PLUS_MINUS_FLAG_DET = PLUS_MINUS_FLAG
				,@INVENTORY_FLAG_DET = INVENTORY_FLAG
				,@CONDITION_CATEGORY_DET = CONDITION_CATEGORY
				,@BASE_VALUE_F_DET = BASE_VALUE_F
				,@BASE_VALUE_T_DET = BASE_VALUE_T
				,@CONDITION_RULE_DET = CONDITION_RULE
				,@ACCRUAL_FLAG_TYPE_DET = ACCRUAL_FLAG_TYPE
				,@COMP_PRICE_RATE_DET = COMP_PRICE_RATE
				,@TAX_CD_DET = TAX_CD
				,@SUPP_CD_DELIVERY_DET = SUPP_CD_DELIVERY
				,@PRICE_DET = PRICE
			FROM #c_result_comp_price
			WHERE ROWNO = @CN

			SET @PO_NO = @PO_NO_PAR;
			SET @PO_ITEM_NO = @PO_ITEM_NO;
			SET @COMP_PRICE_CD = @COMP_PRICE_CD_DET;
			SET @COMP_PRICE_RATE = @COMP_PRICE_RATE_DET;
			SET @INVOICE_FLAG = 'N';
			SET @PO_EXCHANGE_RATE = @l_n_exchange_rate;
			SET @SUPP_CD = @SUPP_CD_DELIVERY_DET;
			SET @PO_CURR = @l_v_curr_cd;
			SET @PO_DETAIL_PRICE = @PRICE_DET;
			SET @PO_DETAIL_AMT = @PO_DETAIL_PRICE * @PO_QUANTITY_NEW_ITM;
			SET @INVENTORY_FLAG = @INVENTORY_FLAG_DET;
			SET @ACCRUAL_POSTING_FLAG = @ACCRUAL_FLAG_TYPE_DET;
			SET @CONDITION_CATEGORY = @CONDITION_CATEGORY_DET;
			SET @SEQ_NO = @SEQ_NO_DET;
			SET @BASE_VALUE_F = @BASE_VALUE_F_DET;
			SET @BASE_VALUE_T = @BASE_VALUE_T_DET;
			SET @CALCULATION_TYPE = @CALCULATION_TYPE_DET;
			SET @PLUS_MINUS_FLAG = @PLUS_MINUS_FLAG_DET;

			IF @INVENTORY_FLAG_DET = 'Y'
			BEGIN
				SET @l_n_sum_mat_price = @l_n_sum_mat_price + ISNULL(@PO_DETAIL_PRICE, 0);-- Remark by jimmy 02/07/2006 PO_DETAIL_AMT;
			END;

			IF ISNULL(@TAX_CD_DET, '') <> ''
			BEGIN
				SET @l_v_tax_cd = @TAX_CD_DET;
			END;

			INSERT INTO TB_R_PO_D (
				PO_NO
				,PO_ITEM
				,MAT_NO
				,MAT_DESC
				,COMP_PRICE_CD
				,COMP_PRICE_RATE
				,INVOICE_FLAG
				,PO_EXCHANGE_RATE
				,SUPP_CD
				,CURRENCY_CD
				,PO_QUANTITY_NEW
				,INVENTORY_FLAG
				,ACCRUAL_POSTING_FLAG
				,CONDITION_CATEGORY
				,SEQ_NO
				,BASE_VALUE_F
				,BASE_VALUE_T
				,CALCULATION_TYPE
				,PLUS_MINUS_FLAG
				,CREATED_BY
				,CREATED_DT
				,CHANGED_BY
				,CHANGED_DT
				)
			VALUES (
				@a_po_no
				,@l_v_po_item_no
				,@MAT_NO_ITM
				,@MAT_DESC_ITM
				,@COMP_PRICE_CD
				,@COMP_PRICE_RATE
				,@INVOICE_FLAG
				,@PO_EXCHANGE_RATE
				,@SUPP_CD
				,@PO_CURR
				,@PO_QUANTITY_NEW_ITM
				,@INVENTORY_FLAG
				,@ACCRUAL_POSTING_FLAG
				,@CONDITION_CATEGORY
				,@SEQ_NO
				,@BASE_VALUE_F
				,@BASE_VALUE_T
				,@CALCULATION_TYPE
				,@PLUS_MINUS_FLAG
				,@USER_ID
				,GETDATE()
				,@USER_ID
				,GETDATE()
				);

			SET @CN = @CN + 1;
		END

		--- PO POSTING
		---- Post into PO Item Data
		INSERT INTO TB_R_PO_ITEM (
			PO_NO
			,PO_ITEM_NO
			,PR_NO
			,PR_ITEM
			,PART_COLOR_SFX
			,UNLIMITED_FLAG
			,TOLERANCE_PERCENTAGE
			,PO_GR_QUANTITY
			,TAX_CD
			,CONTAINER_NO
			,NOTE
			,PROD_PURPOSE_CD
			,MAT_NO
			,SOURCE_TYPE
			,PLANT_CD
			,SLOC_CD
			,SPECIAL_PROCUREMENT_TYPE_CD
			,MAT_DESC
			,PO_QUANTITY_ORIGINAL
			,PO_QUANTITY_NEW
			,PO_QUANTITY_OPEN
			,UNIT_OF_MEASURE_CD
			,PACKING_TYPE
			,PO_MAT_PRICE
			,DELIVERY_DT
			,DELETION_FLAG
			,CREATED_BY
			,CREATED_DT
			,CHANGED_BY
			,CHANGED_DT
			)
		VALUES (
			@a_po_no
			,@l_v_po_item_no
			,@PR_NO_ITM
			,@PR_ITEM_ITM
			,@PART_COLOR_SFX_ITM
			,@UNLIMITED_FLAG_ITM
			,@TOLERANCE_PERCENTAGE_ITM
			,@PO_GR_QUANTITY_ITM
			,@TAX_CD_ITM
			,@CONTAINER_NO_ITM
			,@NOTE_ITM
			,@PROD_PURPOSE_CD_ITM
			,@MAT_NO_ITM
			,@SOURCE_TYPE_ITM
			,@PLANT_CD_ITM
			,@SLOC_CD_ITM
			,@SPECIAL_PROCUREMENT_TYPE_CD_ITM
			,@MAT_DESC_ITM
			,@PO_QUANTITY_ORIGINAL_ITM
			,@PO_QUANTITY_NEW_ITM
			,@PO_QUANTITY_OPEN_ITM
			,@UNIT_OF_MEASURE_CD_ITM
			,@PACKING_TYPE_ITM
			,@PO_MAT_PRICE_ITM
			,@DELIVERY_DT_ITM
			,@DELETION_FLAG_ITM
			,@USER_ID
			,GETDATE()
			,@USER_ID
			,GETDATE()
			);

		UPDATE TB_R_PO_H
		SET CHANGED_BY = @USER_ID
			,CHANGED_DT = GETDATE()
		WHERE PO_NO = @a_po_no;

		IF @IsError = 'N'
		BEGIN
			EXEC dbo.CommonGetMessage 'MSPT00005INF'
				,@MSG_TXT OUTPUT
				,@N_ERR OUTPUT
				,'Create PO Item Detail'

			INSERT INTO TB_R_LOG_D (
				PROCESS_ID
				,SEQUENCE_NUMBER
				,MESSAGE_ID
				,MESSAGE_TYPE
				,[MESSAGE]
				,LOCATION
				,CREATED_BY
				,CREATED_DATE
				)
			SELECT @PROCESS_ID
				,(
					SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
					FROM dbo.TB_R_LOG_D
					WHERE PROCESS_ID = @PROCESS_ID
					)
				,'MSPT00005INF'
				,'INF'
				,'MSPT00005INF : ' + @MSG_TXT
				,@LOG_LOCATION
				,@USER_ID
				,GETDATE()
		END
		ELSE
		BEGIN
			EXEC dbo.CommonGetMessage 'MSPT00006INF'
				,@MSG_TXT OUTPUT
				,@N_ERR OUTPUT
				,'Create PO Item Detail'

			INSERT INTO TB_R_LOG_D (
				PROCESS_ID
				,SEQUENCE_NUMBER
				,MESSAGE_ID
				,MESSAGE_TYPE
				,[MESSAGE]
				,LOCATION
				,CREATED_BY
				,CREATED_DATE
				)
			SELECT @PROCESS_ID
				,(
					SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
					FROM dbo.TB_R_LOG_D
					WHERE PROCESS_ID = @PROCESS_ID
					)
				,'MSPT00006INF'
				,'INF'
				,'MSPT00006INF : ' + @MSG_TXT
				,@LOG_LOCATION
				,@USER_ID
				,GETDATE()
		END

		SELECT @IsError Result, @a_po_no PO_NO, @l_v_po_item_no PO_ITEM_NO
	END TRY

	BEGIN CATCH
		SET @PARAM1 = CONVERT(VARCHAR(1000), ERROR_MESSAGE());

		EXEC dbo.CommonGetMessage 'MPCS00999ERR'
			,@MSG_TXT OUTPUT
			,@N_ERR OUTPUT
			,@PARAM1

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @PROCESS_ID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D
				WHERE PROCESS_ID = @PROCESS_ID
				)
			,'MPCS00999ERR'
			,'ERR'
			,'MPCS00999ERR : ' + @MSG_TXT
			,@LOG_LOCATION
			,@USER_ID
			,GETDATE()

		SELECT 'Y' Result, '' PO_NO, '' PO_ITEM_NO
	END CATCH
END
